using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Threading;

namespace VobAuto
{
    public partial class Form1 : Form
    {

        const uint WM_COMMAND = 0x111;
        const uint WM_SETTEXT = 0xC;
        const uint BM_SETSTATE = 0xF1;

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
        public static extern IntPtr SendMessage(HandleRef hWnd, uint Msg, IntPtr wParam, IntPtr lParam);
        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
        static extern IntPtr SendMessage(HandleRef hWnd, uint Msg, IntPtr wParam, [Out, In]  StringBuilder lParam);
        
        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern bool SendNotifyMessage(HandleRef hWnd, uint Msg, IntPtr wParam,
           IntPtr lParam);


        [DllImport("user32.dll")]
        static extern IntPtr GetDlgItem(IntPtr hDlg, int nIDDlgItem);


        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool EnumWindows(EnumWindowsProc lpEnumFunc, ref IntPtr lParam);
        public delegate bool EnumWindowsProc(IntPtr hWnd, ref IntPtr lParam);

        [DllImport("user32.dll", SetLastError = true)]
        static extern int GetClassName(IntPtr hWnd, StringBuilder lpClassName, int nMaxCount);
        [DllImport("user32.dll", ExactSpelling = true, CharSet = CharSet.Auto)]
        public static extern IntPtr GetParent(IntPtr hWnd);
      

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern int GetWindowText(IntPtr hWnd, [Out] StringBuilder lpString, int nMaxCount);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern int GetWindowTextLength(IntPtr hWnd);
       
        

        public Process VobEdit = new Process();
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            VobEdit.StartInfo.FileName = @"VobEdit.exe";
            VobEdit.StartInfo.WindowStyle = ProcessWindowStyle.Minimized;
            VobEdit.Start();
            VobEdit.WaitForInputIdle(5000);

            IntPtr Hwnd = VobEdit.MainWindowHandle;

            //OPEN DIALOG
            IntPtr OpenBtnHwnd = GetDlgItem(Hwnd, 1002); ;

            SendNotifyMessage(new HandleRef(VobEdit, Hwnd),
              WM_COMMAND,
             new IntPtr(1002),
             OpenBtnHwnd);

           IntPtr OpenHwnd = getDialog(Hwnd, "Open",5000);

           IntPtr EditHwnd = GetDlgItem(OpenHwnd, 1152);
           Thread.Sleep(100);
           StringBuilder file = new StringBuilder(@"D:\VIDEO_TS\VTS_01_1.VOB");
           IntPtr set = SendMessage(new HandleRef(VobEdit, EditHwnd),
                 WM_SETTEXT,
                 IntPtr.Zero, file);

           IntPtr DlgOpenBtnHwnd = GetDlgItem(OpenHwnd,1);
           SendMessage(new HandleRef(VobEdit, OpenHwnd),
             WM_COMMAND, new IntPtr(1), DlgOpenBtnHwnd);
           
            //DEMUX DIALOG
         
            Thread.Sleep(1000);
           IntPtr DemuxBtnHwnd = GetDlgItem(Hwnd, 1005);
           SendNotifyMessage(new HandleRef(VobEdit, Hwnd),
            WM_COMMAND, new IntPtr(1005), DemuxBtnHwnd);

           Thread.Sleep(100);

           IntPtr DemuxHwnd = getDialog(Hwnd, "Dialog",5000);


           IntPtr AllVidBtn = GetDlgItem(DemuxHwnd, 1032);
           IntPtr AllAudBtn = GetDlgItem(DemuxHwnd, 1031);

           SendMessage(new HandleRef(VobEdit, AllVidBtn),
            BM_SETSTATE, new IntPtr(0x1), IntPtr.Zero);
           SendMessage(new HandleRef(VobEdit, AllAudBtn),
       BM_SETSTATE, new IntPtr(0x1), IntPtr.Zero);

           IntPtr OkBtn = GetDlgItem(DemuxHwnd, 1);
           SendMessage(new HandleRef(VobEdit, DemuxHwnd),
             WM_COMMAND, new IntPtr(1), OkBtn);

            //Save As dialog box
           IntPtr SaveAsHwnd = getDialog(Hwnd, "Save As",5000);
            //Replace with path to suitable directory
           StringBuilder outfile = new StringBuilder(@"C:\VTS_01_1.n.xxx");

           IntPtr SaveEditHwnd = GetDlgItem(SaveAsHwnd, 1152);
           set = SendMessage(new HandleRef(VobEdit, SaveEditHwnd),
                 WM_SETTEXT,
                 IntPtr.Zero, outfile);


           IntPtr SaveBtn = GetDlgItem(SaveAsHwnd, 1);
           SendMessage(new HandleRef(VobEdit, SaveAsHwnd),
             WM_COMMAND, new IntPtr(1), SaveBtn);
 




        }

        public IntPtr getDialog(IntPtr Owner, String Caption,int timeout)
        {

            EnumWindowsProc enumProc = delegate(IntPtr handle, ref IntPtr pointer)
           {

               int length = GetWindowTextLength(handle);
               StringBuilder wTitle = new StringBuilder(length + 1);
               GetWindowText(handle, wTitle, wTitle.Capacity);

               if (wTitle.ToString() == Caption)
               {

                   
                   int max = 100;
                   StringBuilder classname = new StringBuilder(max);
                   GetClassName(handle, classname, max);
                   if (classname.ToString() == "#32770")
                   {
                       IntPtr Parent = GetParent(handle);
                       if (Parent == Owner)
                       {
                           pointer = handle;
                           return false;
                       }
                   }
               }
               return true;
           };
            
           DateTime end =DateTime.Now.AddMilliseconds((double)timeout);
            
            IntPtr DlgHwnd = IntPtr.Zero;
            do 
            {
                Thread.Sleep(100);
            EnumWindows(enumProc, ref DlgHwnd);
             }while(DlgHwnd==IntPtr.Zero &&  end > DateTime.Now );
            return DlgHwnd;
        }


    }
}